(function() {'use strict';

    // ================================================
    // ScannerHelper
    // ================================================
    var ScannerHelper = function() {
        this.PROTOCOL_DOMAIN = PUtil.isInFacebookPage() ? window.location.protocol + '//' + window.location.host : 'https://www.facebook.com';
        this.ScanResultsTemplate = FacebookScanResultsTemplate;
    };
    ScannerHelper.prototype.logHeaderSendData = '[Facebook Scan -> send data]';
    ScannerHelper.prototype.logHeaderHandleResponseData = '[Facebook Scan -> handle response data]';
    ScannerHelper.prototype.getSendData_SettingPage = function() {
        var params = {
            'type' : 'GET',
            'data' : null,
            'dataType' : 'html',
            'url' : null
        };

        params.url = this.PROTOCOL_DOMAIN;
        params.url += '/settings?tab=privacy'
        new SendDataLogger(this.logHeaderSendData + ' : ' + 'getSendData_SettingPage', params).getLog();
        return params;
    };
    ScannerHelper.prototype.handleResponse_SettingPage = function(data) {
        new ResponseHandlerLogger(this.logHeaderHandleResponseData + ', ID : ' + 'handleResponse_SettingPage', data).getLog();
        try {
            var scanResult = {

            };
            var htmlContent = TMExt_$(data);
            // get user_id
            var user_id = this.getUserIDFromHtml(data);
            scanResult['user_id'] = user_id;
            //get fb_dtsg
            var fb_dtsg = this.getFb_dtsgfromHtml(htmlContent);
            scanResult['fb_dtsg'] = fb_dtsg;

            return scanResult;
        } catch (e) {
            PSDebug.error(e);
            return null;
        }
    };
    ScannerHelper.prototype.getUserIDFromHtml = function(data) {
        var htmlContent = TMExt_$(data);
        var user_id = null;
        function method_1() {
            try {
                var img_id = htmlContent.find('#pageNav li a.navLink img').attr('id');

                var result = img_id.split('_');
                if (result != null && result[3]) {
                    return result[3];
                }
                return null;
            } catch(err) {
                return null;
            }
        }
        
        function method_2() {
            try {
                var href = htmlContent.find('#pageNav .tinyman a').attr('href');
                if (href) {
                    return href.substring(href.indexOf('id=') + 3, href.indexOf('&'));
                }
                return null;
            } catch(err) {
                return null;
            }
        }
        
        function method_3() {
            try {
                var userid = '';
                userid = substringBetween('envFlush({"user":"', '","locale"', data);
                if ((userid == '0') | (userid == null)) {
                    return null;
                }

                return userid;

            } catch(err) {
                return null;
            }
        }

        try {
            var result = method_1()           
            if(result){
                return result;
            }
            
            result = method_2() 
            if(result){
                return result;
            }
            
            result = method_3() 
            if(result){
                return result;
            }

            return null;
        } catch (e) {
            return null;
        }
    };
    ScannerHelper.prototype.getFb_dtsgfromHtml = function(htmlContent) {
        try {
            return htmlContent.find('input[name="fb_dtsg"]').attr('value');
        } catch (e) {
            return null;
        }
    };
    ScannerHelper.prototype.getSendData = function(id, userID) {
        var params = {
            'type' : 'GET',
            'data' : null,
            'dataType' : 'html',
            'url' : null
        };

        params.url = this.PROTOCOL_DOMAIN;

        switch (String(id)) {
            case '20':
                params.url += '/ajax/settings/granular_privacy/composer.php';
                break;
            case '23':
                params.url += '/ajax/settings/granular_privacy/find_contact.php';
                break;
            case '24':
                params.url += '/ajax/settings/granular_privacy/search.php';
                break;
            case '31':
                params.url += '/ajax/settings/timeline/review.php';
                break;
            case '33':
                params.url += '/ajax/settings/timeline/tagging.php';
                break;
            case '34':
                params.url += '/ajax/settings/timeline/others.php';
                break;
            case '35':
                params.url += '/ajax/settings/tagging/review.php';
                break;
            case '81':
                params.url += '/ajax/settings/applications/friends_share.php';
                break;
            case '82':
                params.url += '/ajax/settings/applications/personalization.php';
                break;
            case '83':
                params.url += '/ajax/settings/applications/old_versions.php';
                break;
        }

        params.url += '?__user=' + userID + '&__a=1'

        new SendDataLogger(this.logHeaderSendData + ' : ' + id, params).getLog();
        return params;
    };
    ScannerHelper.prototype.handleResponse = function(id, data) {
        new ResponseHandlerLogger(this.logHeaderHandleResponseData + ', ID : ' + id, data).getLog();
        var scanResult = this.getScanResultSampleByID(id);
        var htmlContent = this.getHTMLContent(data);
        switch (String(id)) {
            case '20':
                try {
                    var popContent = TMExt_$(htmlContent.jsmods.markup[0][1].__html);

                    var ITEM_LIST_COUNT = this.getNumberOfSettingItems(popContent);
                    if(ITEM_LIST_COUNT != scanResult.ExpectedNumberOfPossibleValue){
                        return null;
                    }

                    // get UI resources
                    var UIResources = this.generateUIResources_20(popContent, ITEM_LIST_COUNT);
                    this.addUIResources(scanResult, UIResources);
                    // get setting item
                    scanResult.Current = this.getCurrentSetting_20(popContent, ITEM_LIST_COUNT);
                    return scanResult;

                } catch (e) {
                    PSDebug.error(e);
                    return null;
                }
                break;
            case '23':
                try {
                    var popContent = TMExt_$(htmlContent.jsmods.markup[0][1].__html);

                    var ITEM_LIST_COUNT = this.getNumberOfSettingItems(popContent);
                    if(ITEM_LIST_COUNT != scanResult.ExpectedNumberOfPossibleValue){
                        return null;
                    }
                    // get UI resources
                    var UIResources = this.generateUIResources_20(popContent, ITEM_LIST_COUNT);
                    this.addUIResources(scanResult, UIResources);
                    // get setting item
                    scanResult.Current = this.getCurrentSetting_23(popContent, ITEM_LIST_COUNT);
                    return scanResult;
                } catch (e) {
                    PSDebug.error(e);
                    return null;
                }
                break;
            case '24':
                try {
                    var popContent = TMExt_$(htmlContent.jsmods.markup[0][1].__html);

                    // get UI resources
                    var UIResources = this.generateUIResources_24(popContent);
                    this.addUIResources(scanResult, UIResources);
                    // get setting item
                    scanResult.Current = this.getCurrentSetting_24(popContent);
                    return scanResult;
                } catch (e) {
                    PSDebug.error(e);
                    return null;
                }
                break;
            case '31':
                try {        
                    // get UI resources
                    var UIResources = this.generateUIResources_31(data);
                    this.addUIResources(scanResult, UIResources);
                    // get setting item
                    scanResult.Current = this.getCurrentSetting_31(data);
                    return scanResult;
                } catch (e) {
                    PSDebug.error(e);
                    return null;
                }
                break;
            case '33':
                try {
                    var popContent = TMExt_$(htmlContent.jsmods.markup[0][1].__html);

                    var ITEM_LIST_COUNT = this.getNumberOfSettingItems(popContent);
                    if(ITEM_LIST_COUNT != scanResult.ExpectedNumberOfPossibleValue){
                        return null;
                    }
                    
                    // get UI resources
                    var UIResources = this.generateUIResources_20(popContent, ITEM_LIST_COUNT);
                    this.addUIResources(scanResult, UIResources);
                    // get setting item
                    scanResult.Current = this.getCurrentSetting_20(popContent, ITEM_LIST_COUNT);
                    return scanResult;
                } catch (e) {
                    PSDebug.error(e);
                    return null;
                }
                break;
            case '34':
                try {
                    var popContent = TMExt_$(htmlContent.jsmods.markup[0][1].__html);

                    var ITEM_LIST_COUNT = this.getNumberOfSettingItems(popContent);
                    if(ITEM_LIST_COUNT != scanResult.ExpectedNumberOfPossibleValue){
                        return null;
                    }
                    // get UI resources
                    var UIResources = this.generateUIResources_20(popContent, ITEM_LIST_COUNT);
                    this.addUIResources(scanResult, UIResources);
                    // get setting item
                    scanResult.Current = this.getCurrentSetting_20(popContent, ITEM_LIST_COUNT);
                    return scanResult;
                } catch (e) {
                    PSDebug.error(e);
                    return null;
                }
                break;
            case '35':
                try {
                    // get UI resources
                    var UIResources = this.generateUIResources_31(data);
                    this.addUIResources(scanResult, UIResources);
                    // get setting item
                    scanResult.Current = this.getCurrentSetting_35(data);
                    return scanResult;
                } catch (e) {
                    PSDebug.error(e);
                    return null;
                }
                break;
            case '81':
                try {
                    var popContent = TMExt_$(htmlContent.jsmods.markup[0][1].__html);

                    // get UI resources
                    var UIResources = this.generateUIResources_81(popContent);
                    this.addUIResources(scanResult, UIResources);
                    // get setting item
                    scanResult.Current = this.getCurrentSetting_81(popContent);
                    return scanResult;
                } catch (e) {
                    PSDebug.error(e);
                    return null;
                }
                break;
            case '82':
                try {
                    // get UI resources
                    var UIResources = this.generateUIResources_82(data);
                    this.addUIResources(scanResult, UIResources);
                    // get setting item
                    scanResult.Current = this.getCurrentSetting_82(data);
                    return scanResult;
                } catch (e) {
                    PSDebug.error(e);
                    return null;
                }
                break;
            case '83':
                try {
                    var popContent = TMExt_$(htmlContent.jsmods.markup[0][1].__html);

                    var ITEM_LIST_COUNT = this.getNumberOfSettingItems(popContent);
                    if(ITEM_LIST_COUNT != scanResult.ExpectedNumberOfPossibleValue){
                        return null;
                    }
                    // get UI resources
                    var UIResources = this.generateUIResources_83(popContent, ITEM_LIST_COUNT);
                    this.addUIResources(scanResult, UIResources);
                    // get setting item
                    scanResult.Current = this.getCurrentSetting_83(popContent, ITEM_LIST_COUNT);
                    return scanResult;
                } catch (e) {
                    PSDebug.error(e);
                    return null;
                }
                break;
        }
    };
    ScannerHelper.prototype.getAllvalidID = function() {
        var allValidID = [];
        for (var i = 0; i < this.ScanResultsTemplate.length; i++) {
            allValidID.push(this.ScanResultsTemplate[i]['ID']);
        }
        return allValidID;
    };
    ScannerHelper.prototype.isValidID = function(id) {
        var allValidID = this.getAllvalidID();
        for (var i = 0; i < allValidID.length; i++) {
            if (id == allValidID[i]) {
                return true;
            }
        }
        return false;
    };

    ScannerHelper.prototype.getScanResultSampleByID = function(id) {
        for (var i = 0; i < this.ScanResultsTemplate.length; i++) {
            if (this.ScanResultsTemplate[i]['ID'] == id) {
                return PUtil.cloneObj(this.ScanResultsTemplate[i]);
            }
        }
    };

    ScannerHelper.prototype.getHTMLContent = function(data) {
        return TMExt_$.parseJSON(data.substring(data.indexOf('{')));
    };

    ScannerHelper.prototype.addUIResources = function(scanResult, UIResources) {
        for (var key in UIResources) {
            scanResult[key] = UIResources[key];
        }
    };

    ScannerHelper.prototype.getCurrentSetting_20 = function(popContent, ITEM_LIST_COUNT) {
        // get setting item
        for (var i = 0; i < ITEM_LIST_COUNT; i++) {
            var value_tag = popContent.find('.uiMenuInner li:eq(' + i + ') a');
            if (value_tag.attr('aria-checked') === 'true') {
                return i;
            }
        }
        // if user has set other group, we will set "custom" (3) here.
        return 3;
    };

    ScannerHelper.prototype.getCurrentSetting_23 = function(popContent, ITEM_LIST_COUNT) {
        // get setting item
        for (var i = 0; i < ITEM_LIST_COUNT; i++) {
            var value_tag = popContent.find('.uiMenuInner li:eq(' + i + ') a');
            if (value_tag.attr('aria-checked') === 'true') {
                return i;
            }
        }
        return null;
    };

    ScannerHelper.prototype.getCurrentSetting_24 = function(popContent) {
        // get setting item
        var value_tag = popContent.find(('input[name="search_filter_public"][checked]'));
        return value_tag.length > 0 ? 1 : 0;
    };

    ScannerHelper.prototype.getCurrentSetting_31 = function(data) {
        var htmlContent = this.getHTMLContent(data);
        var popContent = null;
                    
        for (var i=0; i < 3; i++) {
            if(htmlContent.jsmods.markup[i][2] == 8){
                popContent = TMExt_$(htmlContent.jsmods.markup[i][1].__html);
                break;
            }
        };
        
        // get setting item
        var value_tag = popContent.find('input[name="tag_approval_enabled"]');
        return value_tag.attr('value') === '1' ? 0 : 1;
    };

    ScannerHelper.prototype.getCurrentSetting_35 = function(data) {
        var htmlContent = this.getHTMLContent(data);
        var popContent = null;
                    
        for (var i=0; i < 3; i++) {
            if(htmlContent.jsmods.markup[i][2] == 8){
                popContent = TMExt_$(htmlContent.jsmods.markup[i][1].__html);
                break;
            }
        };
        
        // get setting item
        var value_tag = popContent.find(('input[name="tag_review_enabled"]'));
        return value_tag.attr('value') === '1' ? 0 : 1;
    };

    ScannerHelper.prototype.getCurrentSetting_81 = function(popContent) {
        // get setting item
        return popContent.find('input[type=checkbox][checked]').length > 0 ? 1 : 0;
    };

    ScannerHelper.prototype.getCurrentSetting_82 = function(data) {
        var htmlContent = this.getHTMLContent(data);
        var popContent = null;
        
        for (var i=0; i < htmlContent.jsmods.markup.length; i++) {
            if(htmlContent.jsmods.markup[i][2] == 4){
                popContent = TMExt_$(htmlContent.jsmods.markup[i][1].__html);
                break;
            }
        };
        
        // get setting item
        return popContent.find('#instant_personalization_checkbox').attr('checked') === 'checked' ? 1 : 0;
    };

    ScannerHelper.prototype.getCurrentSetting_83 = function(popContent, ITEM_LIST_COUNT) {
        // get setting item
        for (var i = 0; i < ITEM_LIST_COUNT; i++) {
            var value_tag = popContent.find('.uiMenuInner li:eq(' + i + ') a');
            if (value_tag.attr('aria-checked') === 'true') {
                return i;
            }
        }
        // if user has set other group, we will set "custom" (3) here.
        return 4;
    };

    ScannerHelper.prototype.generateUIResources_20 = function(popContent, selectedItemlength) {
        var UIResources = {
        };

        UIResources.Title = popContent.find('div[class="mbm fwb"]').text();
        UIResources.Desc = popContent.find('div[class="mbm fcg"]').text();

        if (UIResources.Desc == undefined || UIResources.Desc == null || UIResources.Desc == '') {
            UIResources.Desc = UIResources.Title;
        }

        var possibleValueContainer = popContent.find('ul[class="uiMenuInner"]');

        var patternSelectedItem = null;
        if (selectedItemlength == undefined || selectedItemlength == null) {
            patternSelectedItem = 'li';
        } else {
            patternSelectedItem = 'li:lt(' + selectedItemlength + ')';
        }

        var possibleValueList = possibleValueContainer.find(patternSelectedItem);
        var possibleValue = {};
        for (var i = 0; i < possibleValueList.length; i++) {
            // var value = TMExt_$(possibleValueList[i]).attr("data-label");
            var value = TMExt_$(TMExt_$(possibleValueList[i]).find('a span')[0].childNodes[0]).text();
            possibleValue[i] = value;
        }

        UIResources.PossibleValue = possibleValue;

        return UIResources;
    };

    ScannerHelper.prototype.generateUIResources_24 = function(popContent) {
        var UIResources = {
        };

        UIResources.Title = popContent.find('div[class="mbm fwb"]').text();
        UIResources.Desc = popContent.find('label[class="mvm"]').text();

        if (UIResources.Desc == undefined || UIResources.Desc == null || UIResources.Desc == '') {
            UIResources.Desc = UIResources.Title;
        }

        var possibleValue = {
            0 : null,
            1 : null
        };

        UIResources.PossibleValue = possibleValue;
        return UIResources;
    };

    ScannerHelper.prototype.generateUIResources_31 = function(data) {
        var jsonString = data.substring(data.indexOf('{'));

        var res = TMExt_$.parseJSON(jsonString);
        
        var possibleValue = {
        };
        var popContent = null;
        
        for (var i=0; i < 3; i++) {
            if(res.jsmods.markup[i][2] == 2){
                // is "possible value"
                if(res.jsmods.markup[i][0].toString().match(/d$/)){
                    // is "Enabled"
                    possibleValue[0] = res.jsmods.markup[i][1].__html.toString();
                }else if(res.jsmods.markup[i][0].toString().match(/e$/)){
                    // is "Disabled"
                    possibleValue[1] = res.jsmods.markup[i][1].__html.toString();
                }
            } else if(res.jsmods.markup[i][2] == 8){
                // is title and desc
                popContent = TMExt_$(res.jsmods.markup[i][1].__html);
            }
        };
        
        var UIResources = {
        };

        UIResources.Title = popContent.find('div[class="mbm fwb"]').text();
        UIResources.Desc = popContent.find('label[class="mvm"]').text();

        if (UIResources.Desc == undefined || UIResources.Desc == null || UIResources.Desc == '') {
            UIResources.Desc = UIResources.Title;
        }

        UIResources.PossibleValue = possibleValue;

        return UIResources;
    };

    ScannerHelper.prototype.generateUIResources_81 = function(popContent) {
        var UIResources = {
        };

        UIResources.Title = popContent.find('div[class*="mvm mlm"]').text();

        UIResources.Desc = popContent.find('div[class*="mbm fcg"]').text();

        if (UIResources.Desc == undefined || UIResources.Desc == null || UIResources.Desc == '') {
            UIResources.Desc = UIResources.Title;
        }

        var possibleValue = {
            0 : null,
            1 : null
        };

        UIResources.PossibleValue = possibleValue;

        return UIResources;
    };

    ScannerHelper.prototype.generateUIResources_82 = function(data) {
        var htmlContent = this.getHTMLContent(data);
        var popContent = null;
        
        for (var i=0; i < htmlContent.jsmods.markup.length; i++) {
            if(htmlContent.jsmods.markup[i][2] == 4){
                popContent = TMExt_$(htmlContent.jsmods.markup[i][1].__html);
                break;
            }
        };
        
        var UIResources = {
        };
        
        UIResources.Title = popContent.find('label[class*="mvm"]').text();

        UIResources.Desc = popContent.find('div[class*="mbm fcg"]').eq(0).text();

        if (UIResources.Desc == undefined || UIResources.Desc == null || UIResources.Desc == '') {
            UIResources.Desc = UIResources.Title;
        }

        var possibleValue = {
            0 : null,
            1 : null
        };

        UIResources.PossibleValue = possibleValue;

        return UIResources;
    };

    ScannerHelper.prototype.generateUIResources_83 = function(popContent, selectedItemlength) {
        var UIResources = {
        };

        UIResources.Title = popContent.find('div[class*="mvm mlm"]').text();
        UIResources.Desc = popContent.find('div[class*="mbm fcg"]').text();

        if (UIResources.Desc == undefined || UIResources.Desc == null || UIResources.Desc == '') {
            UIResources.Desc = UIResources.Title;
        }

        var possibleValueContainer = popContent.find('ul[class="uiMenuInner"]');

        var patternSelectedItem = null;
        if (selectedItemlength == undefined || selectedItemlength == null) {
            patternSelectedItem = 'li';
        } else {
            patternSelectedItem = 'li:lt(' + selectedItemlength + ')';
        }

        var possibleValueList = possibleValueContainer.find(patternSelectedItem);
        var possibleValue = {};
        for (var i = 0; i < possibleValueList.length; i++) {
            // var value = TMExt_$(possibleValueList[i]).attr("data-label");
            var value = TMExt_$(TMExt_$(possibleValueList[i]).find('a span')[0].childNodes[0]).text();
            possibleValue[i] = value;
        }

        UIResources.PossibleValue = possibleValue;

        return UIResources;
    };

    ScannerHelper.prototype.getNumberOfSettingItems = function(popContent) {
        var li_list = popContent.find('ul[class="uiMenuInner"]>li');

        var count = 0;
        for (var i = 0; i < li_list.length; i++) {
            if (li_list.eq(i).hasClass('uiMenuSeparator')) {
                return count;
            } else {
                count++;
            }
        }
        return null;
    };

    window.FacebookScannerHelper = ScannerHelper;
})();

/*
	ScannerHelper_Under18
*/
(function() {'use strict';

    // ================================================
    // ScannerHelper
    // ================================================

    var ScanResultsTemplate = [{
        Website : 'FACEBOOK',
        ID : 20,
        Risk : [0],
        ExpectedNumberOfPossibleValue : 4,
        possibleFixValue : [0, 1, 2],
        Suggestion : 1,
        Category : 'People_can_see_your_personal_info'
        // Description: 'Who can see your future posts?'
    }, {
        Website : 'FACEBOOK',
        ID : 23,
        Risk : [0, 1],
        ExpectedNumberOfPossibleValue : 3,
        possibleFixValue : [0, 1, 2],
        Suggestion : 2,
        Category : 'Strangers_can_easily_track_you'
        // Description: 'Who can look you up using the email address or phone number you provided'
    }, {
        Website : 'FACEBOOK',
        ID : 24,
        Risk : [1],
        possibleFixValue : [0, 1],
        Suggestion : 0,
        Category : 'Strangers_can_easily_track_you'
        // Description: 'Let other search engines link to your timeline'
    }, {
        Website : 'FACEBOOK',
        ID : 31,
        Risk : [1],
        possibleFixValue : [0, 1],
        Suggestion : 0,
        Category : 'You_can_be_tagged_without_your_permission'
        // Description: 'Review posts friends tag you in before they appear on your timeline'
    }, {
        Website : 'FACEBOOK',
        ID : 33,
        Risk : [0],
        ExpectedNumberOfPossibleValue : 4,
        possibleFixValue : [0, 1, 2],
        Suggestion : 1,
        Category : 'People_can_see_your_personal_info'
        // Description: 'Who can see posts you\'ve been tagged in on your timeline'
    }, {
        Website : 'FACEBOOK',
        ID : 34,
        Risk : [0],
        ExpectedNumberOfPossibleValue : 4,
        possibleFixValue : [0, 1, 2],
        Suggestion : 1,
        Category : 'People_can_see_your_personal_info'
        // Description: 'Who can see what others post on your timeline'
    }, {
        Website : 'FACEBOOK',
        ID : 35,
        Risk : [1],
        possibleFixValue : [0, 1],
        Suggestion : 0,
        Category : 'People_can_see_your_personal_info'
        // Description: 'Review tags people add to your own posts before the tags appear on Facebook'
    }, {
        Website : 'FACEBOOK',
        ID : 81,
        Risk : [1],
        possibleFixValue : [0],
        Suggestion : 0,
        Category : 'People_outside_of_Facebook_can_see_your_info'
        // Description: 'Apps others use'
    }, {
        Website : 'FACEBOOK',
        ID : 82,
        Risk : [1],
        possibleFixValue : [0, 1],
        Suggestion : 0,
        Category : 'People_outside_of_Facebook_can_see_your_info'
        // Description: 'Instant personalization'
    }, {
        Website : 'FACEBOOK',
        ID : 83,
        Risk : [0],
        ExpectedNumberOfPossibleValue : 4,
        possibleFixValue : [0, 1, 2],
        Suggestion : 1,
        Category : 'People_can_see_your_personal_info'
        // Old versions of Facebook for mobile
    }];

    var ScannerHelper = function() {
        this.ScanResultsTemplate = ScanResultsTemplate;
    };

    ScannerHelper.prototype = new FacebookScannerHelper();

    ScannerHelper.prototype.handleResponse = function(id, data) {
        new ResponseHandlerLogger(this.logHeaderHandleResponseData + ', ID : ' + id, data).getLog();
        var scanResult = this.getScanResultSampleByID(id);
        var htmlContent = this.getHTMLContent(data);
        switch (String(id)) {
            case '20':
                try {
                    var popContent = TMExt_$(htmlContent.jsmods.markup[0][1].__html);

                    var ITEM_LIST_COUNT = this.getNumberOfSettingItems(popContent);
                    if(ITEM_LIST_COUNT != scanResult.ExpectedNumberOfPossibleValue){
                        return null;
                    }

                    // get UI resources
                    var UIResources = this.generateUIResources_20(popContent, ITEM_LIST_COUNT);
                    this.addUIResources(scanResult, UIResources);
                    // get setting item
                    scanResult.Current = this.getCurrentSetting_20(popContent, ITEM_LIST_COUNT);
                    return scanResult;

                } catch (e) {
                    PSDebug.error(e);
                    return null;
                }
                break;
            case '23':
                try {
                    var popContent = TMExt_$(htmlContent.jsmods.markup[0][1].__html);

                    var ITEM_LIST_COUNT = this.getNumberOfSettingItems(popContent);
                    if(ITEM_LIST_COUNT != scanResult.ExpectedNumberOfPossibleValue){
                        return null;
                    }
                    // get UI resources
                    var UIResources = this.generateUIResources_20(popContent, ITEM_LIST_COUNT);
                    this.addUIResources(scanResult, UIResources);
                    // get setting item
                    scanResult.Current = this.getCurrentSetting_23(popContent, ITEM_LIST_COUNT);
                    return scanResult;
                } catch (e) {
                    PSDebug.error(e);
                    return null;
                }
                break;
            case '24':
                try {
                    var popContent = TMExt_$(htmlContent.jsmods.markup[0][1].__html);

                    // get UI resources
                    var UIResources = this.generateUIResources_24(popContent);
                    this.addUIResources(scanResult, UIResources);
                    // get setting item
                    scanResult.Current = this.getCurrentSetting_24(popContent);
                    return scanResult;
                } catch (e) {
                    PSDebug.error(e);
                    return null;
                }
                break;
            case '31':
                try {
                    // get UI resources
                    var UIResources = this.generateUIResources_31(data);
                    this.addUIResources(scanResult, UIResources);
                    // get setting item
                    scanResult.Current = this.getCurrentSetting_31(data);
                    return scanResult;
                } catch (e) {
                    PSDebug.error(e);
                    return null;
                }
                break;
            case '33':
                try {
                    var popContent = TMExt_$(htmlContent.jsmods.markup[0][1].__html);

                    var ITEM_LIST_COUNT = this.getNumberOfSettingItems(popContent);
                    if(ITEM_LIST_COUNT != scanResult.ExpectedNumberOfPossibleValue){
                        return null;
                    }
                    // get UI resources
                    var UIResources = this.generateUIResources_20(popContent, ITEM_LIST_COUNT);
                    this.addUIResources(scanResult, UIResources);
                    // get setting item
                    scanResult.Current = this.getCurrentSetting_20(popContent, ITEM_LIST_COUNT);
                    return scanResult;
                } catch (e) {
                    PSDebug.error(e);
                    return null;
                }
                break;
            case '34':
                try {
                    var popContent = TMExt_$(htmlContent.jsmods.markup[0][1].__html);

                    var ITEM_LIST_COUNT = this.getNumberOfSettingItems(popContent);
                    if(ITEM_LIST_COUNT != scanResult.ExpectedNumberOfPossibleValue){
                        return null;
                    }
                    // get UI resources
                    var UIResources = this.generateUIResources_20(popContent, ITEM_LIST_COUNT);
                    this.addUIResources(scanResult, UIResources);
                    // get setting item
                    scanResult.Current = this.getCurrentSetting_20(popContent, ITEM_LIST_COUNT);
                    return scanResult;
                } catch (e) {
                    PSDebug.error(e);
                    return null;
                }
                break;
            case '35':
                try {
                    // get UI resources
                    var UIResources = this.generateUIResources_31(data);
                    this.addUIResources(scanResult, UIResources);
                    // get setting item
                    scanResult.Current = this.getCurrentSetting_35(data);
                    return scanResult;
                } catch (e) {
                    PSDebug.error(e);
                    return null;
                }
                break;
            case '81':
                try {
                    var popContent = TMExt_$(htmlContent.jsmods.markup[0][1].__html);

                    // get UI resources
                    var UIResources = this.generateUIResources_81(popContent);
                    this.addUIResources(scanResult, UIResources);
                    // get setting item
                    scanResult.Current = this.getCurrentSetting_81(popContent);
                    return scanResult;
                } catch (e) {
                    PSDebug.error(e);
                    return null;
                }
                break;
            case '82':
                try {
                    // get UI resources
                    var UIResources = this.generateUIResources_82(data);
                    this.addUIResources(scanResult, UIResources);
                    // get setting item
                    scanResult.Current = this.getCurrentSetting_82(data);
                    return scanResult;
                } catch (e) {
                    PSDebug.error(e);
                    return null;
                }
                break;
            case '83':
                try {
                    var popContent = TMExt_$(htmlContent.jsmods.markup[0][1].__html);

                    var ITEM_LIST_COUNT = this.getNumberOfSettingItems(popContent);
                    if(ITEM_LIST_COUNT != scanResult.ExpectedNumberOfPossibleValue){
                        return null;
                    }
                    // get UI resources
                    var UIResources = this.generateUIResources_83(popContent, ITEM_LIST_COUNT);
                    this.addUIResources(scanResult, UIResources);
                    // get setting item
                    scanResult.Current = this.getCurrentSetting_83(popContent, ITEM_LIST_COUNT);
                    return scanResult;
                } catch (e) {
                    PSDebug.error(e);
                    return null;
                }
                break;
        }
    };

    window.FacebookScannerHelper_Under18 = ScannerHelper;
})();